#define gmpokey_close
return external_call(global.GMPokeyClose);
#define gmpokey_control
return external_call(global.GMPokeyControl,argument0,argument1);
#define gmpokey_get_errorcode
return external_call(global.GMPokeyGetErrorCode);
#define gmpokey_get_errormessage
return external_call(global.GMPokeyGetErrorMessage);
#define gmpokey_get_info
return external_call(global.GMPokeyGetInfo,argument0);
#define gmpokey_init
// GMPOKEY initialisation
var dll, cm, notes, i, j, hex, v1, v2, val;
dll='gmpokey.dll';
cm=dll_stdcall;

// Define external routines
global.GMPokeyClose=external_define(dll,'GMPokeyClose',cm,ty_real,0);
global.GMPokeyControl=external_define(dll,'GMPokeyControl',cm,ty_real,2,ty_real,ty_real);
global.GMPokeyGetErrorCode=external_define(dll,'GMPokeyGetErrorCode',cm,ty_real,0);
global.GMPokeyGetErrorMessage=external_define(dll,'GMPokeyGetErrorMessage',cm,ty_string,0);
global.GMPokeyGetInfo=external_define(dll,'GMPokeyGetInfo',cm,ty_string,1,ty_real);
global.GMPokeyInit=external_define(dll,'GMPokeyInit',cm,ty_real,5,ty_real,ty_real,ty_real,ty_real,ty_real);
global.GMPokeyRecStart=external_define(dll,'GMPokeyRecStart',cm,ty_real,1,ty_string);
global.GMPokeyRecStop=external_define(dll,'GMPokeyRecStop',cm,ty_real,0);
global.GMPokeySound=external_define(dll,'GMPokeySound',cm,ty_real,4,ty_real,ty_real,ty_real,ty_real);
global.GMPokeySound2=external_define(dll,'GMPokeySound2',cm,ty_real,5,ty_real,ty_real,ty_real,ty_real,ty_real);
global.GMPokeyReset=external_define(dll,'GMPokeyReset',cm,ty_real,0);
global.GMPokeyUpdate=external_define(dll,'GMPokeyUpdate',cm,ty_real,0);

// Hexadecimal aid
hex='0123456789ABCDEF';

// Array of 64 pure-tone notes (distortion levels 10 and 14)
notes[1]='F3E6D9CCC1B5ADA29990888079726C66605B55514C4844403C3935322F2D2A28';
notes[1]+='2523211F1D1C1A18171614131211100F0E0D0C0B0A0908070605040302010000';

// Array of 64 bass-tone notes (distortion level 12)
notes[2]='FFF1E4D8CAC0B5ABA2998E877F79737066615A55524B48433F3C393733302D2A';
notes[2]+='282524211F1E1C1B19171615131211100F0E0D0C0B0A09080706050403020100';

for (j=1; j<3; j+=1)
  for (i=0; i<64; i+=1)
   {
     v1=string_char_at(notes[j],2*i+1);
     v2=string_char_at(notes[j],2*i+2);
     val=16*(string_pos(v1,hex)-1)+string_pos(v2,hex)-1;
     if j=1 global.GMPokey10[i]=val else global.GMPokey12[i]=val;
   }

return external_call(global.GMPokeyInit,argument0,argument1,argument2,argument3,argument4);
#define gmpokey_rec_start
return external_call(global.GMPokeyRecStart,argument0);
#define gmpokey_rec_stop
return external_call(global.GMPokeyRecStop);
#define gmpokey_reset
return external_call(global.GMPokeyReset);
#define gmpokey_sound
return external_call(global.GMPokeySound,argument0,argument1,argument2,argument3);
#define gmpokey_sound2
return external_call(global.GMPokeySound2,argument0,argument1,argument2,argument3,argument4);
#define gmpokey_update
return external_call(global.GMPokeyUpdate);
